#ifndef BISON_Y_TAB_H
# define BISON_Y_TAB_H

#ifndef YYSTYPE
typedef union {
    char         	*str;
    int          	 integer;
    basic_type_t 	 basic_type;
    BinRel     	        *binrel;
    binop_t      	 binop;
    RExpr        	*rexpr;
    BExpr        	*bexpr;
    WhenExpr     	*when_expr;
    WhereExpr    	*where_expr;
    Fun          	*fun;
    Values       	*values;
    Range	 	*range;
    Expr         	*expr;
    MatrixExpr   	*matrix;
    FunCallExpr  	*fun_call;
    Update       	*update;
    list<basic_type_t> 	*type_list;
    list<const char*> 	*string_list;
    list<Expr*>  	*expr_list;
    list<RExpr*> 	*rexpr_list;
    list<WhenExpr*>  	*when_expr_list;
    list<Update*>    	*update_list;
    list<Declaration*>  *decl_list;
    Declaration  	*decl;
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
# define	ID	257
# define	INTEGER	258
# define	GLOBALS	259
# define	PARAMETERS	260
# define	LOCALS	261
# define	IN	262
# define	END	263
# define	VAL	264
# define	MATRIX	265
# define	FUN	266
# define	CHAR	267
# define	INT	268
# define	FLOAT	269
# define	WHERE	270
# define	WHEN	271
# define	TRUE	272
# define	GTE	273
# define	LTE	274
# define	NEQ	275
# define	AND	276
# define	OR	277


extern YYSTYPE yylval;

#endif /* not BISON_Y_TAB_H */
